﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Soubory
{
    public partial class Window : Form
    {
        public Window()
        {
            InitializeComponent();
        }

        private void show(TreeNodeCollection nodes,
                          DirectoryInfo dir,
                          int level)
        {
            TreeNode top = new TreeNode (dir.Name);
            top.ToolTipText = dir.FullName;
            top.Tag = dir;
            // FileInfo[] files = dir.GetFiles();
            try
            {
                DirectoryInfo[] dirs = dir.GetDirectories();
                if (level > 0)
                    foreach (DirectoryInfo d in dirs)
                    {
                        show(top.Nodes, d, level-1);
                    }
            }
            catch (Exception c) 
            {
            }
            nodes.Add(top);
        }

        private void testButton_Click(object sender, EventArgs e)
        {
            DriveInfo[] drives = DriveInfo.GetDrives();
            foreach (DriveInfo drive in drives)
            {
                DirectoryInfo dir = drive.RootDirectory;
                show(tree.Nodes, dir, 1);
            }
            tree.ShowNodeToolTips = true;

            /*
            foreach (FileInfo f in files)
            {
                ListViewItem item = new ListViewItem();
                item.Text = f.Name;
                item.SubItems.Add ("" + f.Length);
                item.ToolTipText = f.FullName;
                list.Items.Add(item);
            }
            list.ShowItemToolTips = true;
            */
        }

        private void tree_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            TreeNode top = e.Node;
            foreach (TreeNode node in top.Nodes)
            {
                DirectoryInfo dir = node.Tag as DirectoryInfo;
                try
                {
                    DirectoryInfo[] dirs = dir.GetDirectories();
                    if (node.Nodes.Count == 0)
                        foreach (DirectoryInfo d in dirs)
                            show(node.Nodes, d, 1);
                }
                catch (Exception c)
                {
                }
            }
        }
    }
}
